package binarytree.core;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.Queue;

public class BinarySearchTree<T extends Comparable<T>> {
	private TreeNode<T> root;
	
	public BinarySearchTree() {
		root = null;
	}
	
	public ArrayList<T> inorder() {
		//TODO
		return null;
	}
	
	public ArrayList<T> preorder() {
		//TODO
		return null;
	}
	
	public ArrayList<T> postorder() {
		//TODO
		return null;
	}
	
	public int size() {
		//TODO
		return 0;
	}
	
	public boolean contains(T value) {
		//TODO
		return false;
	}
	
	public void insert(T value) {
		//TODO
	}
	
	public void remove(T value) {
		//TODO
	}
	
	public ArrayList<ArrayList<ArrayList<T>>> levelOrder() {
		ArrayList<ArrayList<ArrayList<T>>> levels = new ArrayList<>();
		if (root == null) {return levels;}
		
		levels.add(new ArrayList<>());
		Queue<TreeNode<T>> q = new LinkedList<>();
		q.add(root);
		for (;;) {
			TreeNode<T> node = q.remove();
			if (node.getLevel() != levels.size() - 1) {
				if (allSentinels(levels.get(levels.size() - 1))) {
					levels.remove(levels.size() - 1);
					return levels;
				}
				levels.add(new ArrayList<>());
			}
			ArrayList<T> entry = new ArrayList<>();
			if (node.get() != null) {
				entry.add(node.get());
			}
			levels.get(levels.size() - 1).add(entry);
			if (node.hasLeft()) {
				q.add(node.getLeft());
				entry.add(node.getLeft().get());
			} else {
				addSentinelTo(q, node.getLevel());
			}
			if (node.hasRight()) {
				q.add(node.getRight());
				entry.add(node.getRight().get());
			} else {
				addSentinelTo(q, node.getLevel());
			}
		}
	}
	
	private void addSentinelTo(Queue<TreeNode<T>> q, int parentLevel) {
		TreeNode<T> sentinel = new TreeNode<>(null);
		sentinel.setLevel(parentLevel + 1);
		q.add(sentinel);
	}
	
	private static <T> boolean allSentinels(ArrayList<ArrayList<T>> entries) {
		for (ArrayList<T> entry: entries) {
			if (entry.size() > 0) {
				return false;
			}
		}
		return true;
	}
}
